import ft.otp.verify.OTPVerify;
import java.util.Scanner;
import java.util.Map;

/********************************************************************
  
  	RFC4226 JAVA SAMPLE RESULT:
    Secret = 0x3132333435363738393031323334353637383930

    Count    HOTP
    0        755224
    1        287082
    2        359152
    3        969429
    4        338314
    5        254676
    6        287922
    7        162583
    8        399871
    9        520489

    /////////////////////////////////////////////////

TOTP JAVA SAMPLE RESULT:
    Secret = 0x3132333435363738393031323334353637383930
    T0 = UTC EPOCH
    X = 30

    +------------+-----------------------+------------------+--------+
    | Unix Time  |       UTC Time        |    Value of T    |  OTP   |
    +------------+-----------------------+------------------+--------+
    | 1000000000 |  2001-09-09 01:46:40  | 0000000001FCA055 | 864010 |
    +------------+-----------------------+------------------+--------+
    | 1111111111 |  2005-03-18 01:58:31  | 00000000023523ED | 050471 |
    +------------+-----------------------+------------------+--------+
    | 1234567890 |  2009-02-13 23:31:30  | 000000000273EF07 | 005924 |
    +------------+-----------------------+------------------+--------+
    | 2000000000 |  2033-05-18 03:33:20  | 0000000003F940AA | 279037 |
    +------------+-----------------------+------------------+--------+
    
    
    
#define OTP_SUCCESS					(0x00000000L) //ɹ

#define OTP_ERR_INVALID_PARAMETER	(0x00000001L) //Ч

#define OTP_ERR_CHECK_PWD			(0x00000002L) //֤ʧ

#define OTP_ERR_SYN_PWD				(0x00000003L) //ͬʧ

#define OTP_ERR_REPLAY				(0x000000004) //ͬһ̬


*******************************************************************/

public class Demo {

	private Demo() {}

    //ֻ֤ӿڵ
	private static void testCheckPwdC200()
	{
		String seed = "560AEB58419E246D0F6581EA023FC167E3B886B2";
		String sOTP = "";
		Map hashMap;
		Scanner sc = new Scanner(System.in);
		int iDrift = 0;
		long lSucc = 0;
		
		
		System.out.println("demo ITSecurity_CheckPwdC200,input:\"quit\" to end");
		
		System.out.print("please input otp:");
        while(!((sOTP = sc.next()).equals("quit")))
        {
        	//System.out.println(sOTP);
			
			
			hashMap = OTPVerify.ITSecurity_CheckPwdC200(
				seed,									//Կ
				System.currentTimeMillis()/1000,		//ñӿڼĵǰʱ
				0,										//0
				60,										//60Ϊÿ60µĶ̬
				iDrift, 								//ƯֵڵӲʱƫֲ˵
				20,										//֤ڣֲ˵ 
				lSucc,									//ɹֵڵӲʱƫֲ˵
				sOTP);									//Ҫ֤Ķ̬OTP
		
			Long nReturn = (Long)hashMap.get("returnCode");
			System.out.println("returnCode = " + nReturn);
			
			if(nReturn == OTPVerify.OTP_SUCCESS)
			{
				System.out.println("check success");
				System.out.println("currentSucc = " + hashMap.get("currentUTCEpoch"));
				System.out.println("currentDrift = " + hashMap.get("currentDrift"));
				
				iDrift = ((Long)hashMap.get("currentDrift")).intValue();
				lSucc = ((Long)hashMap.get("currentUTCEpoch")).longValue();
				
			}
			else
			{
				System.out.println("check fail");
			}
			
			System.out.print("please input otp:");
        }		  
		
		
	
			
	}
	
	//ֻͬӿڵ
	private static void testSyncPwdC200()
	{
		String seed = "560AEB58419E246D0F6581EA023FC167E3B886B2";
		String sOTP1 = "";
		String sOTP2 = "";
		Map hashMap;
		Scanner sc = new Scanner(System.in);
		int iDrift = 0;
		long lSucc = 0;
		Long nReturn;
		
		System.out.println("demo ET_Syncz201,input:\"quit\" to end");
		
	
	            
	    System.out.print("please input otp1:");
        while(!((sOTP1 = sc.next()).equals("quit")))
        {
        	System.out.print("please input otp2:");
        	sOTP2 = sc.next();
        	
        	
        	hashMap = OTPVerify.ITSecurity_PSW_SYNC200(seed, System.currentTimeMillis()/1000, 0, 60, iDrift, 40, lSucc, 
	            sOTP1,sOTP2);
	            
	        nReturn = (Long)hashMap.get("returnCode");
			System.out.println("returnCode = " + nReturn); 
	            
        	if(nReturn == OTPVerify.OTP_SUCCESS)
			{
				System.out.println("syn success");
				System.out.println("currentSucc = " + hashMap.get("currentUTCEpoch"));
				System.out.println("currentDrift = " + hashMap.get("currentDrift"));
				
				iDrift = ((Long)hashMap.get("currentDrift")).intValue();
				lSucc = ((Long)hashMap.get("currentUTCEpoch")).longValue();
				
			}
			else
			{
				System.out.println("syn fail");
			}
			
			System.out.print("please input otp1:");
        }
	
	}
	
	
	//ET z201֤ӿڵ
	private static void testCheckPwdz201()
	{
		String seed = "ll276DFE997728E6E083A2A5162671527348B97092246C9D1D";
		String sOTP = "";
		Map hashMap;
		Scanner sc = new Scanner(System.in);
		int iDrift = 0;
		long lSucc = 0;
		Long nReturn;
		
		System.out.println("demo ET_CheckPwdz201,input:\"quit\" to end");
		
		
		System.out.print("please input otp:");
        while(!((sOTP = sc.next()).equals("quit")))
        {
        	//System.out.println(sOTP);
			
			
			hashMap = OTPVerify.ET_CheckPwdz201(
				seed,									//Կ
				System.currentTimeMillis()/1000,		//ñӿڼĵǰʱ
				0,										//0
				60,										//60Ϊÿ60µĶ̬
				iDrift, 								//ƯֵڵӲʱƫֲ˵
				20,										//֤ڣֲ˵ 
				lSucc,									//ɹֵڵӲʱƫֲ˵
				sOTP);									//Ҫ֤Ķ̬OTP
		
			nReturn = (Long)hashMap.get("returnCode");
			System.out.println("returnCode = " + nReturn);
			
			if(nReturn == OTPVerify.OTP_SUCCESS)
			{
				System.out.println("check success");
				System.out.println("currentSucc = " + hashMap.get("currentUTCEpoch"));
				System.out.println("currentDrift = " + hashMap.get("currentDrift"));
				
				iDrift = ((Long)hashMap.get("currentDrift")).intValue();
				lSucc = ((Long)hashMap.get("currentUTCEpoch")).longValue();
				
			}
			else
			{
				System.out.println("check fail");
			}
			
			System.out.print("please input otp:");
        }		  
			
	}

	//ET z201ͬӿڵ
	private static void testSyncPwdz201()
	{
		String seed = "ll276DFE997728E6E083A2A5162671527348B97092246C9D1D";
		String sOTP1 = "";
		String sOTP2 = "";
		Map hashMap;
		Scanner sc = new Scanner(System.in);
		int iDrift = 0;
		long lSucc = 0;
		Long nReturn;
		
		System.out.println("demo ET_Syncz201,input:\"quit\" to end");
		
	
	            
	    System.out.print("please input otp1:");
        while(!((sOTP1 = sc.next()).equals("quit")))
        {
        	System.out.print("please input otp2:");
        	sOTP2 = sc.next();
        	
        	
        	hashMap = OTPVerify.ET_Syncz201(seed, System.currentTimeMillis()/1000, 0, 60, iDrift, 40, lSucc, 
	            sOTP1,sOTP2);
	            
	        nReturn = (Long)hashMap.get("returnCode");
			System.out.println("returnCode = " + nReturn); 
	            
        	if(nReturn == OTPVerify.OTP_SUCCESS)
			{
				System.out.println("syn success");
				System.out.println("currentSucc = " + hashMap.get("currentUTCEpoch"));
				System.out.println("currentDrift = " + hashMap.get("currentDrift"));
				
				iDrift = ((Long)hashMap.get("currentDrift")).intValue();
				lSucc = ((Long)hashMap.get("currentUTCEpoch")).longValue();
				
			}
			else
			{
				System.out.println("syn fail");
			}
			
			System.out.print("please input otp1:");
        }
		
	}
	
    public static void main(String[] args) 
    {
    	//ֻ
    	//System.out.println();
    	//testCheckPwdC200();
    	
    	//System.out.println();
    	//testSyncPwdC200();
    	
    	//ET z201
    	//System.out.println();
    	testCheckPwdz201();
    	
    	//System.out.println();
    	//testSyncPwdz201();
    }
}

